<?php define ('VERZE','20230226');
$TextChyby="";
$Characters=array(
  "Unsafe"=>array("=","<",">","\r","\n",   "&","*","\\","|","%","'","\""),
    "Safe"=>array("÷",'‹','›', '·', '¶',   '§','•','™','¦','‰','‘','“' ),
 "Display"=>array("=",'‹','›', '' ,'<br/>','&','*','\\','|','%','‘','“' ),
"TextArea"=>array("=",'‹','›', "\r","\n",  '&','*','\\','|','%','‘','“' ));
$Quotes=array(
"Unsafe"=>array("\\\\","\\'",'\\"')
 ,"Safe"=>array("\\",'‘','“'));

function SafeRequest($varName) // odstraňuje zakázané znaky z HTTP GET/POST
{global $Characters,$Quotes;
if (!isset($_REQUEST[$varName])) return "";
else return str_replace($Characters["Unsafe"],$Characters["Safe"],trim($_REQUEST[$varName]));
}

function Display($text) // Překóduje zakázané znaky textu mimo <> ' ", konce řádků na <br>
{global $Characters;
return str_replace($Characters["Safe"],$Characters["Display"],$text);
}
function TextArea($text) // Překóduje zakázané znaky textu mimo <> ' ", konce řádků na \r\n
{global $Characters;
return str_replace($Characters["Safe"],$Characters["TextArea"],$text);
}

function ChybaDb($db,$sql="") // vrací true/false
{global $TextChyby; if (!$db || @mysqli_errno($db))
{$TextChyby.="\r\n<br/>Během SQL příkazu <pre>$sql</pre><br/>došlo k chybě databáze
<i>".@mysqli_error($db)."</i>"; return true;
}else return false;
}

function ZobrazChyby()
{global $TextChyby; if ($TextChyby)
{echo "<br clear='all'/><fieldset class='ERR'>$TextChyby</fieldset>"; 
$TextChyby=""; return(true);} 
else return(false);
}

function CmpHomo($a,$b) // Porovnávací funkce pro řazení účtů v GetHomoi()
{return ($a['hid']<$b['hid'])?-1:1;
}

function GetHomoi($db) // vrací pole všech uživatelů
{$sql="SELECT * from homo;";$result=mysqli_query($db,$sql);
ChybaDb($db,$sql); $homoi=array();
while ($hom=mysqli_fetch_assoc($result)) $homoi[]=$hom;
usort($homoi,"CmpHomo"); return $homoi;}

function GetImagoe($db,$dies) // Ke dni $dies ("1".."7") načte pole šablon $imagoe
{$sql="SELECT * FROM imago WHERE dies='$dies' ORDER BY hora;";
$result=mysqli_query($db,$sql);
ChybaDb($db,$sql); $imagoe=array();
while ($imago=@mysqli_fetch_assoc($result)) if ($imago['ritus']) $imagoe[]=$imago;
return $imagoe;
}

function GetPromulgo($db,$o,$W) // Načtení ohlášek pro týden $o$W
{$promulgo=""; $sql="SELECT * FROM log WHERE labor='PR' AND id='$o$W';";
$result=mysqli_query($db,$sql);ChybaDb($db,$sql);
while ($log=@mysqli_fetch_assoc($result))
$promulgo=$log['text'];
return $promulgo;
}

function GetSession($db) // Vrací pole $homo přihlášeného uživatele anebo false.
{global $ExpiraceMinut;
if (!$sid=SafeRequest('sid')) if (!$sid=$_COOKIE['sid']) return false;
if (strlen($sid)<>32) return false;
$sql="SELECT * from homo WHERE sid='$sid';";
$result=@mysqli_query($db,$sql);
if (ChybaDb($db,$sql)) return false;
$homo=mysqli_fetch_assoc($result);
if (!$homo) return false;
if ($homo['IP']<>$_SERVER['REMOTE_ADDR']) return false;
if (time()>$homo['tempus'])  // Pokud relace expirovala.
  {mysqli_query($db,"UPDATE homo SET tempus=0,sid=0 WHERE sid=$sid;");
   setcookie('sid',false);return false;}
$expirace=time()+60*$ExpiraceMinut;
mysqli_query($db,"UPDATE homo SET tempus=$expirace WHERE sid=$sid;");
return $homo;
}

function Datum($Ymd) // Převádí datum ze tvaru 20120301 na 1.3.2012
{return substr($Ymd,6,2).'.'.substr($Ymd,4,2).'.'.substr($Ymd,0,4);}

function Noto($db,$labor,$id="",$text="") // Zaznamená událost do deníku.
{if (!$homo=GetSession($db)) return false;
global $Characters;
$hid=$homo['hid']; $IP=$homo['IP'];
$textSafe=str_replace($Characters["Unsafe"],$Characters["Safe"],trim($text));
$sql="INSERT INTO log SET tempus=".time().",hid='$hid',IP='$IP',labor='$labor',id='$id',text='$textSafe';";
mysqli_query($db,$sql);return ChybaDb($db,$sql);
}

function ZobrazHlavu($title="Bohoslužby",$logo=true,$BodyId="",$Fatal=true) // Vypíše HTML kód začátku stránky.
{header('Content-type: text/html; charset=utf-8'); global $Home;
$body=$BodyId?"<body id='$BodyId'>":"<body>";
echo "<!DOCTYPE html>
<html><head>
<meta charset='UTF-8'>
<link rel='stylesheet' href='missae.css' type='text/css'>
<meta name='author' content='vit\$oft' />
<meta name='source' content='http://vitsoft.info/missae/popis.php' />
<title>$title</title>
</head>
$body";
if ($logo) echo "
<a href='$Home'><img src='logo.jpg' id='LOGO' title='Návrat na stránku farnosti' /></a>\r\n";
if ($Fatal) if (ZobrazChyby()) {ZobrazPatu();exit();}
flush();}

function ZobrazPatu($tisk="")  // Vypíše HTML kód konce stránky.
{global $NazevServeru,$Folder;
ZobrazChyby();echo "\r\n<p>&nbsp;</p><div class='CALX'>$tisk $NazevServeru/$Folder
<br/>&nbsp; &nbsp; &nbsp; Vytvořeno v aplikaci
<a href='popis.php'>Missae</a> ".VERZE." &copy;
<a href='https://www.vitsoft.info/about.me'>vit\$oft</a>
</div></body></html>";
}

function PripojDb($ServerDb,$KontoDb,$HesloDb,$NazevDb,$CheckTables=true) // Připojení k databázi.
{global $TextChyby;
$db = @mysqli_connect($ServerDb,$KontoDb,$HesloDb,$NazevDb);
if (ChybaDb($db)) {$TextChyby.="
<br/>Databáze serveru <b>$ServerDb</b> pro účet <b>$KontoDb</b> není dostupná."; return false;}
//mysqli_select_db($NazevDb,$db);
mysqli_select_db($db,$NazevDb);
if (ChybaDb($db)) {$TextChyby.="
<br/>Databáze s názvem <b>$NazevDb</b> není na serveru <b>$ServerDb</b> dostupná.
Postupujte podle <a href='popis.php'>návodu k instalaci</a>."; return false;}
if ($CheckTables && mysqli_num_rows(mysqli_query($db,"show tables"))<4) $TextChyby.="
<br/>V databázi nejsou vytvořeny tabulky. Spusťte skript <a href='instaluj.php'>instaluj.php</a>.";
mysqli_query($db,"set names 'utf8'");
return $db;}

function dateoW($tm) // Vraci rok a cislo tydne yyyynn
{return date("o",$tm).substr("0".date("W",$tm),-2);
}

function t2time($t) // převede číslo týdne $t=YYYYWn na time odpovídající neděli 0h předcházející týdnu týdnu $t
{if (!$t) $t=dateoW();  $MT=strtotime("last  Monday" ,
 (substr($t,0,4)-1970)*31557600 + substr($t,4,2)*604800);
while (dateoW($MT)<$t) $MT=strtotime("next Monday 00:00:00",$MT);
while (dateoW($MT)>$t) $MT=strtotime("last Monday 00:00:00",$MT);
return $MT-86400;
}

$idies=array( // Definuje řádky šablony, zkratky a plné názvy svátků a dnů v týdnu
"SD"=>"Štědrý den",
"HB"=>"Hod Boží vánoční",
"ST"=>"Sv.Štěpána",
"NR"=>"Nový rok",
"P3"=>"Popeleční středa",
"Z4"=>"Zelený čtvrtek",
"V5"=>"Velký pátek",
"B6"=>"Bílá sobota",
"V7"=>"Velikonoční neděle",
"V1"=>"Velikonoční pondělí",
"JD"=>"Sv.Josefa dělníka",
"CM"=>"Sv.Cyrila a Metoděje",
"SV"=>"Sv.Václava",
"7"=>"Neděle",
"1"=>"Pondělí",
"2"=>"Úterý",
"3"=>"Středa",
"4"=>"Čtvrtek",
"5"=>"Pátek",
"6"=>"Sobota",
"0"=>"Neděle"
);

function Kalendar($db,$Y) // $Y je rok, napr. 2012.
{$K=array();
// Vrací pole $K ročního kalendáře: 365 nebo 366 členů s klíči [yyyy0101], [yyyy0102],..[yyyy1231]
// Pole každého klíče obsahuje následující členy:
// [0] 'P'..prac.den  'V'..den prac.klidu  'S'..státem uznaný svátek
// [1] občanské jmeniny, např. "Kamil"
// [2] církevní 'P'..(nezávazná) památka   'S'..svátek   'L'..slavnost  mimo pohyblivých
// [3] církevní jmeniny, např. "sv. Matěj" 
// [4] liturgická barva 'B', 'C', 'Z', 'F', 'R'.
// [5] slavnost, např. "Seslání Ducha svatého"
// [6] číslo týdne, např. 201105.
// [7] círk.týden, např. "6.mezidobí".
// [8] dies - den pro výběr šablony "1".."7","SD","HB" atd., viz $idies

// Výstupní pole $K je cachováno v databázi.
$sql="CREATE TABLE IF NOT EXISTS `cache` (
`Y`   SMALLINT UNSIGNED COMMENT 'kalendářní rok',
`K`   LONGBLOB COMMENT 'pole kalendáře',
PRIMARY KEY (`Y`)
) COMMENT 'Cache kalendářů' , ENGINE = myisam;";
mysqli_query($db,$sql); if (ChybaDb($db,$sql)) ZobrazChyby();

$sql="SELECT `K` FROM cache WHERE Y=$Y;";
if ($sK=@mysqli_fetch_row(mysqli_query($db,$sql))) return unserialize($sK[0]);
// Pokud kalendář roku $Y ještě není v cache, spočítá se a uloží.
// 
// Definice pevných občanských a církevních svátků. Pět položek každého dne definují
// 1. státní svátečnost 'S'=svátek   '?'=není státní svátek
// 2. občanské jmeniny
// 3. církevní svátečnost 'P'amátka / 'S'vátek / s'L'avnost
// 4. církevní jmeniny
// 5. liturgická barva 'B'ílá/'C'ervená. Ostatní barvy 'F'ialová/'Z'elená/'R'ůžová budou doplněny dle období.
//
// Aby se případné změny a opravy učiněné ručně v níže uvedené definici $Svatky uplatnily v aplikaci,
// je třeba v databázi vymazat (DROP nebo TRUNCATE)  tabulku `cache`.
$Svatky=array(
'0101'=>array('S',"Nový rok",'L',"Matka Boží Panna Maria",'B'),
'0102'=>array('?',"Karina, Vasil",'P',"sv. Basil Veliký, sv. Řehoř Naziánský",'B'),
'0103'=>array('?',"Radmil, Radmila",'P',"sv. Jenovéfa",'B'),
'0104'=>array('?',"Diana",'P',"bl. Anděla z Foligna",'B'),
'0105'=>array('?',"Dalimil",'P',"sv. Telesfor",'B'),
'0106'=>array('?',"Tři králové",'L',"Zjevení Páně",'B'),
'0107'=>array('?',"Vilma",'P',"sv. Rajmund z Penafortu"),
'0108'=>array('?',"Čestmír",'P',"sv. Severin"),
'0109'=>array('?',"Valtr, Vladan",'P',"sv. Julián"),
'0110'=>array('?',"Břetislav",'P',"sv. Agathon (Dobromil)"),
'0111'=>array('?',"Bohdana",'P',"ct. Marie Elekta"),
'0112'=>array('?',"Pravoslav",'P',"sv. Probus"),
'0113'=>array('?',"Edita",'P',"sv. Hilarius z Poitiers"),
'0114'=>array('?',"Radovan",'P',"sv. Sáva Srbský"),
'0115'=>array('?',"Alice",'P',"sv. Pavel Poustevník"),
'0116'=>array('?',"Ctirad",'P',"sv. Marcel I."),
'0117'=>array('?',"Drahoslav",'P',"sv. Antonín Veliký"),
'0118'=>array('?',"Vladislav, Vladislava",'P',"Panna Maria, Matka jednoty křesťanů"),
'0119'=>array('?',"Doubravka",'P',"sv. Priska"),
'0120'=>array('?',"Ilona, Sebastián",'P',"sv. Fabián, sv. Šebestián",'C'),
'0121'=>array('?',"Běla",'P',"sv. Anežka Římská",'C'),
'0122'=>array('?',"Slavomír, Slavomíra",'P',"sv. Vincenc"),
'0123'=>array('?',"Zdeněk",'P',"sv. Ildefons"),
'0124'=>array('?',"Milena",'P',"sv. František Saleský"),
'0125'=>array('?',"Miloš",'S',"Obrácení sv. Pavla",'B'),
'0126'=>array('?',"Zora",'P',"sv. Timotej a Titus"),
'0127'=>array('?',"Ingrid",'P',"sv. Anděla Mericiová"),
'0128'=>array('?',"Otýlie",'P',"sv. Tomáš Akvinský"),
'0129'=>array('?',"Zdislava",'P',"sv. Valerius"),
'0130'=>array('?',"Erna, Robin",'P',"sv. Martina"),
'0131'=>array('?',"Marika",'P',"sv. Jan Bosko"),
'0201'=>array('?',"Hynek",'P',"sv. Gelasius"),
'0202'=>array('?',"Nela",'S',"Uvedení Páně do chrámu (Hromnice)"),
'0203'=>array('?',"Blažej",'P',"sv. Blažej, sv. Ansgar"),
'0204'=>array('?',"Jarmila",'P',"sv. Ondřej Corsini"),
'0205'=>array('?',"Dobromila",'P',"sv. Agáta (Háta, Dobruše)",'C'),
'0206'=>array('?',"Vanda",'P',"sv. Pavel Miki a druhové"),
'0207'=>array('?',"Verona, Veronika",'P',"sv. Richard"),
'0208'=>array('?',"Milada",'P',"sv. Jeroným Emiliani, ct. Mlada"),
'0209'=>array('?',"Apolena",'P',"sv. Apollonie",'B'),
'0210'=>array('?',"Mojmír",'P',"sv. Scholastika",'B'),
'0211'=>array('?',"Božena, Dezider",'P',"Panna Marie Lurdská"),
'0212'=>array('?',"Slavěna, Slávka",'P',"sv. Damián"),
'0213'=>array('?',"Věnceslav, Věnceslava",'P',"sv. Kateřina Ricciová"),
'0214'=>array('?',"Valentýn, Valentýna",'P',"sv. Valentit"),
'0215'=>array('?',"Jiřina",'P',"sv. Jiřina"),
'0216'=>array('?',"Ljuba",'P',"sv. Juliána"),
'0217'=>array('?',"Miloslava",'P',"sv. Alexius a druhové"),
'0218'=>array('?',"Gizela",'P',"sv. Simeon"),
'0219'=>array('?',"Patrik",'P',"bl. Godšalk"),
'0220'=>array('?',"Oldřich",'P',"sv. Nikefor"),
'0221'=>array('?',"Eleonora, Lenka",'P',"sv. Petr Damiani"),
'0222'=>array('?',"Petr",'S',"Stolec sv. Petra",'B'),
'0223'=>array('?',"Svatopluk",'P',"sv. Polykarp"),
'0224'=>array('?',"Matěj, Matyáš",'P',"sv. Modest"),
'0225'=>array('?',"Liliana",'P',"sv. Valburga"),
'0226'=>array('?',"Dora, Dorota",'P',"sv. Alexandr"),
'0227'=>array('?',"Alexandr",'P',"sv. Gabriel od Bolestné Panny Marie"),
'0228'=>array('?',"Lumír",'P',"sv. Roman"),
'0229'=>array('?',"Horymír",'P',"sv. Kasián"),
'0301'=>array('?',"Albín, Bedřich, Bedřiška",'P',"sv. Suitbert"),
'0302'=>array('?',"Anežka",'P',"sv. Simplicius"),
'0303'=>array('?',"Kamil",'P',"sv. Kunhuta"),
'0304'=>array('?',"Stela",'P',"sv. Kazimír"),
'0305'=>array('?',"Kazimír",'P',"sv. Teofil (Bohumil)"),
'0306'=>array('?',"Miroslav",'P',"sv. Friedrich (Bedřich, Miroslav)"),
'0307'=>array('?',"Tomáš",'P',"sv. Perpetua a Felicita (Blažena)",'C'),
'0308'=>array('?',"Gabriela, Zoltán",'P',"sv. Jan z Boha"),
'0309'=>array('?',"Františka",'P',"sv. Františka Římská"),
'0310'=>array('?',"Viktorie",'P',"sv. Jan Ogilvie"),
'0311'=>array('?',"Anděla, Angelika",'P',"sv. Eulogius z Kordoby"),
'0312'=>array('?',"Řehoř",'P',"sv. Kvirin"),
'0313'=>array('?',"Růžena",'P',"sv. Patricie (Vlasta)"),
'0314'=>array('?',"Matylda, Rút",'P',"sv. Matylda"),
'0315'=>array('?',"Ida",'P',"sv. Longin"),
'0316'=>array('?',"Amos, Elena, Herbert",'P',"sv. Heribert"),
'0317'=>array('?',"Vlastimil, Vlastimila",'P',"sv. Patrik"),
'0318'=>array('?',"Eduard",'P',"sv. Cyril Jeruzalémský"),
'0319'=>array('?',"Josef, Josefa",'L',"slavnost sv. Josefa",'B'),
'0320'=>array('?',"Světla, Světlana",'P',"sv. Archip"),
'0321'=>array('?',"Radek",'P',"bl. Serapion"),
'0322'=>array('?',"Leona",'P',"sv. Epafrodit"),
'0323'=>array('?',"Ivona",'P',"sv. Turibius z Mongroveja"),
'0324'=>array('?',"Gabriel",'P',"sv. Kateřina Švédská"),
'0325'=>array('?',"Marián",'L',"Zvěstování Páně, sv. Dismas",'B'),
'0326'=>array('?',"Emanuel",'P',"sv. Haštal"),
'0327'=>array('?',"Dita",'P',"sv Rupert"),
'0328'=>array('?',"Soňa",'P',"sv. Rogát"),
'0329'=>array('?',"Taťána",'P',"sv. Ludolf (Slavomil)"),
'0330'=>array('?',"Arnošt, Ernest",'P',"sv. Jan Klimak"),
'0331'=>array('?',"Kvido",'P',"bl. Balbína"),
'0401'=>array('?',"Hugo",'P',"sv. Makarius (Blahomír)"),
'0402'=>array('?',"Erika",'P',"sv. František z Pauly"),
'0403'=>array('?',"Richard",'P',"sv. Nikita"),
'0404'=>array('?',"Ivana",'P',"sv. Izidor"),
'0405'=>array('?',"Mirka, Miroslava",'P',"sv.Vincenc Ferrerský"),
'0406'=>array('?',"Vendula, Venuše",'P',"sv.Notger"),
'0407'=>array('?',"Heřman, Hermína",'P',"sv. Jan Křtitel de la Salle"),
'0408'=>array('?',"Ema",'P',"sv. Albert"),
'0409'=>array('?',"Dušan",'P',"sv. Marie Kleofášova"),
'0410'=>array('?',"Darja",'P',"sv. Michael de Sanctis"),
'0411'=>array('?',"Izabela",'P',"sv. Stanislav"),
'0412'=>array('?',"Julius",'P',"sv. Julius"),
'0413'=>array('?',"Aleš",'P',"sv. Martin I."),
'0414'=>array('?',"Vincenc",'P',"sv. Lambert"),
'0415'=>array('?',"Anastázie",'P',"sv. Anastázie"),
'0416'=>array('?',"Irena",'P',"sv. Bernardeta Soubirousová"),
'0417'=>array('?',"Rudolf",'P',"sv. Inocenc"),
'0418'=>array('?',"Valérie",'P',"sv. Krescens (Rostislav)"),
'0419'=>array('?',"Rastislav, Rostislav",'P',"sv. Ema"),
'0420'=>array('?',"Marcela",'P',"sv. Hugo"),
'0421'=>array('?',"Alexandra",'P',"sv. Anselm, sv. Konrád (Altötong)"),
'0422'=>array('?',"Evženie",'P',"sv. Leonid"),
'0423'=>array('?',"Vojtěch, Vojtěška",'S',"sv. Vojtěch"),
'0424'=>array('?',"Jiří",'P',"sv. Jiří, sv. Fidel ze Sigmaringy"),
'0425'=>array('?',"Marek",'S',"sv. Marek"),
'0426'=>array('?',"Oto",'P',"sv. Richarius"),
'0427'=>array('?',"Jaroslav",'P',"sv. Zita"),
'0428'=>array('?',"Vlastislav",'P',"sv. Petr Chanel, sv. Ludvík Maria Grignion z Monfortu"),
'0429'=>array('?',"Robert",'P',"sv. Kateřina Sienská"),
'0430'=>array('?',"Blahoslav",'P',"sv. Zikmund, sv. Pius V."),
'0501'=>array('S',"Svátek práce",'P',"sv. Josef, dělník"),
'0502'=>array('?',"Zikmund",'P',"sv. Atanáš"),
'0503'=>array('?',"Alex, Alexej",'S',"sv. Filip a Jakub Mladší",'C'),
'0504'=>array('?',"Květoslav",'P',"sv. Florián"),
'0505'=>array('?',"Klaudie",'P',"sv. Gothard"),
'0506'=>array('?',"Radoslav, Radoslava",'P',"sv. Jan Sarkander",'C'),
'0507'=>array('?',"Stanislav",'P',"sv. Benedikt II."),
'0508'=>array('S',"Den vítězství",'P',"Panna Maria, Prostřednice všech milostí"),
'0509'=>array('?',"Ctibor",'P',"sv. Hermus"),
'0510'=>array('?',"Blažena",'P',"sv. Izidor"),
'0511'=>array('?',"Svatava",'P',"sv. Ignác z Láconi"),
'0512'=>array('?',"Pankrác",'P',"sv. Pankrác, sv. Nereus a Achilleus"),
'0513'=>array('?',"Servác",'P',"sv. Ondřej Hubert Fournet"),
'0514'=>array('?',"Bonifác",'S',"sv. Matěj, apoštol",'C'),
'0515'=>array('?',"Sofie, Žofie",'P',"sv. Žofie"),
'0516'=>array('?',"Přemysl",'S',"sv. Jan Nepomucký",'C'),
'0517'=>array('?',"Aneta",'P',"sv. Paschal Baylon"),
'0518'=>array('?',"Nataša",'P',"sv. Jan I."),
'0519'=>array('?',"Ivo",'P',"sv. Petr Celestýn"),
'0520'=>array('?',"Zbyšek",'P',"sv. Klement M. Hofbauer,<br/> sv. Bernardin Sienský"),
'0521'=>array('?',"Monika",'P',"sv. Ondřej Bobola"),
'0522'=>array('?',"Emil",'P',"sv. Julie"),
'0523'=>array('?',"Vladimír, Vladimíra",'P',"sv. Jan Křtitel de Rossi"),
'0524'=>array('?',"Jana, Vanesa",'P',"sv. Vincenc Lerinský"),
'0525'=>array('?',"Viola",'P',"sv. Beda Ctihodný, sv. Řehoř VII.,<br/>sv.Marie Magdaléna de Pazzi"),
'0526'=>array('?',"Filip",'P',"sv. Filip Neri"),
'0527'=>array('?',"Valdemar",'P',"sv. Augustin z Canterbury"),
'0528'=>array('?',"Vilém, Viliam",'P',"sv. Emil"),
'0529'=>array('?',"Maxim, Maxmilián",'P',"sv. Maximin"),
'0530'=>array('?',"Ferdinand",'P',"sv. Zdislava"),
'0531'=>array('?',"Kamila",'S',"Navštívení Panny Marie"),
'0601'=>array('?',"Laura",'P',"sv. Justin",'C'),
'0602'=>array('?',"Jarmil",'P',"sv. Marcelin a Petr"),
'0603'=>array('?',"Kevin, Tamara",'P',"sv. Karel Lwanga a druhové",'C'),
'0604'=>array('?',"Dalibor",'P',"sv. František Caracciolo"),
'0605'=>array('?',"Dobroslav, Dobroslava",'P',"sv. Bonifác"),
'0606'=>array('?',"Norbert",'P',"sv. Norbert"),
'0607'=>array('?',"Iveta, Slavoj",'P',"sv. Robert"),
'0608'=>array('?',"Medard",'P',"sv. Medard"),
'0609'=>array('?',"Stanislava",'P',"sv. Efrém Syrský"),
'0610'=>array('?',"Gita, Margita",'P',"sv. Maxim"),
'0611'=>array('?',"Bruno, Flóra",'P',"sv. Barnabáš"),
'0612'=>array('?',"Antonie",'P',"sv. Jan z Fakunda"),
'0613'=>array('?',"Antonín",'P',"sv. Antonín z Padovy"),
'0614'=>array('?',"Herta, Roland, Vasil",'P',"sv. Anastáz"),
'0615'=>array('?',"Vít",'P',"sv. Vít"),
'0616'=>array('?',"Zbyněk",'P',"sv. Benon (Zbyněk)"),
'0617'=>array('?',"Adolf",'P',"sv. Řehoř Barbarigo"),
'0618'=>array('?',"Milan, Milana",'P',"sv. Marina"),
'0619'=>array('?',"Leo, Leoš",'P',"sv. Jan Nepomuk Neumann, sv. Romuald"),
'0620'=>array('?',"Květa, Květuše",'P',"sv. Silverius"),
'0621'=>array('?',"Alois, Aloisie",'P',"sv. Alois Gonzaga"),
'0622'=>array('?',"Pavla",'P',"sv. Jan Fisher a Tomáš More"),
'0623'=>array('?',"Zdeňka",'P',"sv. Josef Cafasso"),
'0624'=>array('?',"Jan",'L',"Narození sv. Jana Křtitele",'B'),
'0625'=>array('?',"Ivan",'P',"sv. Vilém, ct. Ivan"),
'0626'=>array('?',"Adrian, Adriána",'P',"sv. Jan a Pavel"),
'0627'=>array('?',"Ladislav, Ladislava",'P',"sv. Cyril Alexandrijský"),
'0628'=>array('?',"Lubomír, Lubomíra",'P',"sv. Irenej (Lubomír)"),
'0629'=>array('?',"Petr, Pavel",'L',"sv. Petr a Pavel",'C'),
'0630'=>array('?',"Šárka",'P',"sv. prvomučedníci římští"),
'0701'=>array('?',"Jaroslava",'P',"sv. Theopold (Děpold)"),
'0702'=>array('?',"Patricie",'P',"sv. Ota"),
'0703'=>array('?',"Radomír, Radomíra",'S',"sv. Tomáš"),
'0704'=>array('?',"Prokop",'P',"sv. Prokop, sv. Alžběta Portugalská"),
'0705'=>array('S',"Cyril, Metoděj",'L',"sv. Cyril a Metoděj",'B'),
'0706'=>array('S',"upálení mistra Jana Husa",'P',"sv. Marie Gorettiová"),
'0707'=>array('?',"Bohuslava",'P',"sv. Wilibald"),
'0708'=>array('?',"Nora",'P',"sv. Kilián"),
'0709'=>array('?',"Drahoslava, Drahuše",'P',"sv. Veronika Gorettiová"),
'0710'=>array('?',"Amálie, Libuše",'P',"sv. Amálie (Libuše)"),
'0711'=>array('?',"Helga, Olga",'S',"sv. Benedikt",'B'),
'0712'=>array('?',"Bořek",'P',"sv. Jan Qualbert"),
'0713'=>array('?',"Markéta",'P',"sv. Jindřich"),
'0714'=>array('?',"Karolína",'P',"bl. Hroznata, sv. Kamil de Lellis"),
'0715'=>array('?',"Jindřich",'P',"sv. Bonaventura",'B'),
'0716'=>array('?',"Luboš",'P',"Panna Maria Karmelská"),
'0717'=>array('?',"Martina",'P',"bl. Česlav a sv. Hyacint"),
'0718'=>array('?',"Drahomír, Drahomíra",'P',"sv. Emilián"),
'0719'=>array('?',"Čeněk",'P',"sv. Makrina"),
'0720'=>array('?',"Ilja",'P',"sv. Eliáš"),
'0721'=>array('?',"Vítězslav, Vítězslava",'P',"sv. Vavřinec z Brindisi"),
'0722'=>array('?',"Magda, Magdaléna",'P',"sv. Marie Magdaléna",'B'),
'0723'=>array('?',"Larisa, Libor",'S',"sv. Brigita",'B'),
'0724'=>array('?',"Kristýna",'P',"sv. Kristina"),
'0725'=>array('?',"Jakub",'S',"sv. Jakub Starší, sv. Kryštof",'C'),
'0726'=>array('?',"Anna, Anita",'P',"sv. Jáchym a Anna",'B'),
'0727'=>array('?',"Věroslav",'P',"sv. Gorazd a druhové"),
'0728'=>array('?',"Alina, Viktor",'P',"sv. Nazarius a Celsus"),
'0729'=>array('?',"Marta",'P',"sv. Marta",'B'),
'0730'=>array('?',"Bořivoj",'P',"sv. Petr Chyzolog"),
'0731'=>array('?',"Ignác",'P',"sv. Ignác z Loyoly"),
'0801'=>array('?',"Oskar",'P',"sv. Alfons z Liguori",'B'),
'0802'=>array('?',"Gustav",'P',"sv. Eusebius, sv. Petr Julián Eymard"),
'0803'=>array('?',"Miluše",'P',"sv. Lydie"),
'0804'=>array('?',"Dominik, Dominika",'P',"sv. Jan Maria Vianney",'B'),
'0805'=>array('?',"Kristián, Milivoj",'P',"Posvěcení římské baziliky P. Marie Sněžné"),
'0806'=>array('?',"Oldřiška",'S',"Proměnění Páně",'B'),
'0807'=>array('?',"Lada",'P',"sv. Kajetán, sv. Sixtus II. a druhové"),
'0808'=>array('?',"Soběslav",'P',"sv. Dominik",'B'),
'0809'=>array('?',"Roman",'P',"sv Terezie Benedikta od Kříže (Edith Stein)",'C'),
'0810'=>array('?',"Vavřinec",'S',"sv. Vavřinec",'C'),
'0811'=>array('?',"Zuzana",'P',"sv. Klára",'B'),
'0812'=>array('?',"Klára",'P',"sv.Euplus, sv. Jana Fr. de Chantal"),
'0813'=>array('?',"Alena",'P',"sv. Poncián a Hippolyt, sv. Jan Berchmans"),
'0814'=>array('?',"Alan",'P',"sv. Maxmilián Kolbe"),
'0815'=>array('?',"Hana",'L',"Nanebevzetí Panny Marie",'B'),
'0816'=>array('?',"Jáchym",'P',"sv. Štěpán Uherský"),
'0817'=>array('?',"Petra",'P',"sv. Myron"),
'0818'=>array('?',"Helena",'P',"sv. Helena"),
'0819'=>array('?',"Ludvík",'P',"sv. Jan Eudes"),
'0820'=>array('?',"Bernard",'P',"sv. Bernard",'B'),
'0821'=>array('?',"Johana",'P',"sv. Pius X."),
'0822'=>array('?',"Bohuslav",'P',"Panna Maria Královna",'B'),
'0823'=>array('?',"Sandra",'P',"sv. Růžena z Limy"),
'0824'=>array('?',"Bartoloměj",'S',"sv. Bartoloměj",'C'),
'0825'=>array('?',"Radim",'P',"sv. Ludvík, sv.Benedikt a druhové, sv. Josef Kalasanský"),
'0826'=>array('?',"Luděk",'P',"ct. Martin Středa"),
'0827'=>array('?',"Otakar",'P',"sv. Monika",'B'),
'0828'=>array('?',"Augustýn",'P',"sv. Augustin"),
'0829'=>array('?',"Evelína",'P',"Umučení sv. Jana Křtitele",'C'),
'0830'=>array('?',"Vladěna",'P',"sv. Felix, sv. Fiakr"),
'0831'=>array('?',"Pavlína",'P',"sv. Rajmund"),
'0901'=>array('?',"Linda, Samuel",'P',"sv. Jiljí"),
'0902'=>array('?',"Adéla",'P',"sv. Justus"),
'0903'=>array('?',"Bronislav, Bronislava",'P',"sv. Řehoř Veliký",'B'),
'0904'=>array('?',"Jindřiška, Rozálie",'P',"sv. Růžena z Viterba"),
'0905'=>array('?',"Boris",'P',"sv. Viktorin (Vítězslav)"),
'0906'=>array('?',"Boleslav",'P',"sv. Magnus"),
'0907'=>array('?',"Regína",'P',"sv. Melichar Grodecký"),
'0908'=>array('?',"Mariana",'S',"Narození Panny Marie",'B'),
'0909'=>array('?',"Daniela",'P',"sv. Petr Klaver"),
'0910'=>array('?',"Irma",'P',"bl. Karel Spinola"),
'0911'=>array('?',"Denis, Denisa",'P',"sv. Emil"),
'0912'=>array('?',"Marie",'P',"Jméno P.Marie, sv. Quido"),
'0913'=>array('?',"Lubor",'P',"sv. Jan Zlatoústý",'B'),
'0914'=>array('?',"Radka",'S',"Povýšení svatého kříže",'C'),
'0915'=>array('?',"Jolana",'P',"Panna Maria Bolestná",'B'),
'0916'=>array('?',"Lidmila, Ludmila",'P',"sv. Ludmila"),
'0917'=>array('?',"Naďa, Naděžda",'P',"sv. Kornélius a Cyprián, sv. Robert Bellarmin"),
'0918'=>array('?',"Kryštof",'P',"sv. Josef Kupertinský"),
'0919'=>array('?',"Zita",'P',"Sv. Januárius"),
'0920'=>array('?',"Oleg",'P',"sv. Ondřej Kim Taegon, Pavel Chong Hasang a druhové",'C'),
'0921'=>array('?',"Matouš",'S',"sv. Matouš",'C'),
'0922'=>array('?',"Darina",'P',"sv. Mořic a druhové"),
'0923'=>array('?',"Berta",'P',"sv. Konstanc z Ankony, sv. Pio z Pietrelciny"),
'0924'=>array('?',"Jaromír, Jaromíra",'P',"sv. Gerard (Jaromír)"),
'0925'=>array('?',"Zlata, Zlatuše",'P',"sv. Kleofáš"),
'0926'=>array('?',"Andrea",'P',"sv. Kosma a Damián"),
'0927'=>array('?',"Jonáš",'P',"sv. Vincenc z Paula"),
'0928'=>array('S',"Václav",'L',"sv. Václav",'C'),
'0929'=>array('?',"Michal, Michael",'S',"sv. Michael, Gabriel a Rafael",'B'),
'0930'=>array('?',"Jeroným",'P',"sv. Jeroným"),
'1001'=>array('?',"Igor",'P',"sv. Terezie od Dítěte Ježíše"),
'1002'=>array('?',"Olivie, Oliver",'P',"sv. andělé strážní",'B'),
'1003'=>array('?',"Bohumil",'P',"sv. Maxmilián"),
'1004'=>array('?',"František",'P',"sv. František z Assisi",'B'),
'1005'=>array('?',"Eliška",'P',"sv. Palmác"),
'1006'=>array('?',"Hanuš",'P',"sv. Bruno"),
'1007'=>array('?',"Justýna, Sergej",'P',"Panna Maria Růžencová",'B'),
'1008'=>array('?',"Věra",'P',"sv. Simeon"),
'1009'=>array('?',"Sára, Štefan",'P',"sv. Dionýsius a druhové, sv. Jan Leonardi"),
'1010'=>array('?',"Marina",'P',"sv. Paulin"),
'1011'=>array('?',"Andrej",'P',"sv. German"),
'1012'=>array('?',"Marcel",'P',"sv. Radim"),
'1013'=>array('?',"Koloman, Renáta",'P',"sv. Eduard"),
'1014'=>array('?',"Agáta",'P',"sv. Kalist I."),
'1015'=>array('?',"Tereza, Terezie",'P',"sv. Terezie od Ježíše",'B'),
'1016'=>array('?',"Galina, Havel",'P',"sv. Hedvika, sv. Markéta Maria Alacoque"),
'1017'=>array('?',"Heda, Hedvika",'P',"sv. Ignác Antiochijský",'C'),
'1018'=>array('?',"Lukáš",'S',"sv. Lukáš",'C'),
'1019'=>array('?',"Michala, Michaela",'P',"sv. Izák Jogues a druhové, sv. Pavel od Kříže"),
'1020'=>array('?',"Vendelín",'P',"sv. Irena"),
'1021'=>array('?',"Brigita",'P',"sv. Hilarion"),
'1022'=>array('?',"Sabina",'P',"sv. Maria Salome"),
'1023'=>array('?',"Teodor",'P',"sv. Jan Kapistránský"),
'1024'=>array('?',"Nina",'P',"sv. Antonín Maria Klaret"),
'1025'=>array('?',"Beáta",'P',"sv. Kryšpín"),
'1026'=>array('?',"Erik",'P',"sv. Rustik"),
'1027'=>array('?',"Šarlota, Zoe, Zoja",'P',"sv. Frumencius"),
'1028'=>array('S',"Den vzniku samostatného československého státu",'S',"sv. Šimon a Juda",'C'),
'1029'=>array('?',"Silvie, Sylva",'P',"sv. Narcis"),
'1030'=>array('?',"Tadeáš",'P',"sv. Marcel"),
'1031'=>array('?',"Štěpánka",'P',"sv. Wolfgang"),
'1101'=>array('?',"Felix",'L',"Všichni svatí",'B'),
'1102'=>array('?',"Památka zesnulých",'P',"Vzpomínka na všechny věrné zemřelé",'F'),
'1103'=>array('?',"Hubert",'P',"sv. Martin de Porres"),
'1104'=>array('?',"Karel, Karla",'P',"sv. Karel Boromejský",'B'),
'1105'=>array('?',"Emerich, Miriam",'P',"sv. Zachariáš a Alžběta"),
'1106'=>array('?',"Liběna",'P',"sv. Leonard (Linhart)"),
'1107'=>array('?',"Saskie",'P',"sv. Wilibrord"),
'1108'=>array('?',"Bohumír, Bohumíra",'P',"sv. Gottfried (Bohumír)"),
'1109'=>array('?',"Bohdan",'S',"Posvěcení lateránské baziliky",'B'),
'1110'=>array('?',"Evžen",'P',"sv. Lev Veliký",'B'),
'1111'=>array('?',"Martin",'P',"sv. Martin Tourský",'B'),
'1112'=>array('?',"Benedikt",'P',"sv. Josafat",'C'),
'1113'=>array('?',"Tibor",'P',"sv. Anežka Česká"),
'1114'=>array('?',"Sáva",'P',"sv. Mikuláš Tavelič"),
'1115'=>array('?',"Leopold",'P',"sv. Albert Veliký"),
'1116'=>array('?',"Otmar",'P',"sv. Markéta Skotská, sv. Gertruda"),
'1117'=>array('S',"Gertruda, Mahulena",'P',"sv. Alžběta Uherská",'B'),
'1118'=>array('?',"Romana",'P',"Posvěcení římských bazilik sv. Petra a Pavla"),
'1119'=>array('?',"Alžběta",'P',"sv. Mechtilda"),
'1120'=>array('?',"Nikol, Nikola",'P',"sv. Felix z Valois"),
'1121'=>array('?',"Albert",'P',"Zasvěcení Panny Parie v Jeruzalémě",'B'),
'1122'=>array('?',"Cecílie",'P',"sv. Cecílie",'C'),
'1123'=>array('?',"Klement",'P',"sv. Klement I., sv. Kolumbán"),
'1124'=>array('?',"Emílie",'P',"sv. Ondřej Dung-Lac a druhové",'C'),
'1125'=>array('?',"Kateřina",'P',"sv. Kateřina Alexandrijská"),
'1126'=>array('?',"Artur",'P',"sv. Silvestr"),
'1127'=>array('?',"Oxana, Xenie",'P',"sv. Virgil"),
'1128'=>array('?',"René",'P',"sv. Mansuet (Miloslav)"),
'1129'=>array('?',"Zina",'P',"sv. Saturnin"),
'1130'=>array('?',"Ondřej",'S',"sv. Ondřej",'C'),
'1201'=>array('?',"Iva",'P',"sv. Edmund Kampián"),
'1202'=>array('?',"Blanka",'P',"sv. Bibiána"),
'1203'=>array('?',"Svatoslav, Svatoslava",'P',"sv. František Xaverský",'B'),
'1204'=>array('?',"Barbara, Barbora",'P',"sv Barbora, sv. Jan Damašský"),
'1205'=>array('?',"Jitka",'P',"sv. Sába"),
'1206'=>array('?',"Mikuláš, Nikolas",'P',"sv. Mikuláš"),
'1207'=>array('?',"Ambrož, Benjamín",'P',"sv. Ambrož",'B'),
'1208'=>array('?',"Květoslava",'L',"Panna Maria počatá bez poskvrny prvotního hříchu",'B'),
'1209'=>array('?',"Vratislav, Vratislava",'P',"sv. Valerie"),
'1210'=>array('?',"Julie",'P',"sv. Julie a Eulálie"),
'1211'=>array('?',"Dana, Danuše",'P',"sv. Damas I. (Hostivít)"),
'1212'=>array('?',"Simona",'P',"sv. Jana Františka de Chantal, Panna Maria Guadalupská"),
'1213'=>array('?',"Lucie",'P',"sv. Lucie (Světluše)",'C'),
'1214'=>array('?',"Lýdie",'P',"sv. Jan od Kříže",'B'),
'1215'=>array('?',"Radan, Radana",'P',"sv. Valerián"),
'1216'=>array('?',"Albína",'P',"sv. Adelhaida (Adéla)"),
'1217'=>array('?',"Daniel",'P',"sv. Lazar"),
'1218'=>array('?',"Miloslav",'P',"sv. Rufus a Zosim"),
'1219'=>array('?',"Ester",'P',"bl. Urban"),
'1220'=>array('?',"Dagmar, Dáša",'P',"sv. Dominik Sionský"),
'1221'=>array('?',"Natálie",'P',"sv. Petr Kanisius"),
'1222'=>array('?',"Šimon",'P',"sv. Františka Cabrini, sv. Servul"),
'1223'=>array('?',"Vlasta",'P',"sv. Jan Kentský"),
'1224'=>array('S',"Adam, Eva",'S',"Štědrý den"),
'1225'=>array('S',"Boží hod vánoční",'L',"Narození Páně",'B'),
'1226'=>array('S',"Štěpán",'S',"sv. Štěpán",'B'),
'1227'=>array('?',"Melánie, Žaneta",'S',"sv. Jan Evangelista",'B'),
'1228'=>array('?',"Bohumila",'S',"sv. Mláďátka betlémská",'C'),
'1229'=>array('?',"Judita",'P',"sv. Tomáš Becket",'B'),
'1230'=>array('?',"David",'P',"sv. Evžen",'B'),
'1231'=>array('?',"Silvestr",'P',"sv. Silvestr I.",'B')
);
// Popis liturgického roku je převzat z aplikace "Liturgický kalendář",
// kterou napsal Petr Handlar  handlar@katolik.cz

/*
Stavba liturgického kalendáře

Liturgický rok je velmi jednoduchá záležitost. Začíná 1. nedělí adventní
a končí v sobotu před první nedělí adventní.
Na rozdíl od občanského roku, který začíná 1. ledna, není počátek svázán s konkrétním datem,
ale je „pohyblivý"; to proto, že je spojen se 4. nedělí před 25. prosincem.
Protože 25. prosinec připadá každý rok na jiný den v týdnu, má i 1. adventní neděle
každý rok jiné datum. Pokud si počátek liturgického roku chcete spočítat sami,
odpočítejte od 25. prosince zpět 4 neděle.

Sv. Rodiny Ježíše, Marie a Josefa : Neděle v oktávu Narození Páně anebo, není-li v oktávu neděle, 30. prosince:
28.12.2008, 27.12.2009, 26.12.2010, 30.12.2011, 30.12.2012, 29.12.2013

K Vánocùm se pojí další pohyblivý či posuvný svátek. Je to Svátek Svaté rodiny, který se slaví
vždy v neděli po Narození Páně, a Svátek Křtu Páně, který se slaví v neděli po Zjevení Páně, tj. po 6. lednu.
Z toho, co jsem dosud napsal, je již zřejmý rozdíl mezi pevným svátkem a pohyblivým.
Pevný je svázán s konkrétním datem (např. Narození Páně 25. prosince,
Zjevení Páně 6. ledna, Uvedení Páně do chrámu 2. února, sv. Petra a Pavla 29. června atd.),
pohyblivý svátek je vázán na určitý den v týdnu, ještě třeba s další závislostí, proto se
každý rok slaví s jiným datem.

Typickým pohyblivým svátkem je největší slavnost liturgického roku – Velikonoce.
Ty se slaví v neděli po prvním jarním úplňku. Takže k určení, kdy se slaví, potřebujeme vědět,
kdy úplněk nastane. To se ovšem dá spočítat. A v neděli po něm jsou Velikonoce.
Počátek postní doby zase odpočítáme od Velikonoc: napočítejte zpìt 6 neděl a dostanete 1. neděli postní.
Středa před ní je tzv. Popeleční, což je začátek postní doby. Od Velikonoc se pak počítají
další svátky a slavnosti: 40. den po Zmrtvýchvstání se slaví Nanebevstoupení Páně (je to vždy ve čtvrtek),
10 dní po něm je neděle Seslání Ducha Svatého. V neděli po Seslání slavíme Slavnost Nejsvětější Trojice,
po ní na čtvrtek připadne Slavnost Těla a Krve Páně.
Pátek dalšího týdne je věnován oslavě Nejsvětějšího Srdce Ježíšova. A poslední pohyblivý svátek
je poslední neděle liturgického roku, která připomíná Krista Krále.
*/ 

// Nejprve se zkopírují statická data $Svatky, označí soboty a neděle [0],[8] vypočte týden [5]
$tm=mktime(0,0,0,1,1,$Y); $tmEnd=mktime(0,0,0,1,1,$Y+1);
while ($tm<$tmEnd)
{$md=date("md",$tm);
$oW=dateoW($tm);
$w=date("w",$tm); $volno=($w==0||$w==6)?'V':'P';
$dies=$w?$w:7;
// $dies pro pevné svátky:
if ($md=="1224") $dies="SD";
if ($md=="1225") $dies="HB";
if ($md=="1226") $dies="ST";
if ($md=="0101") $dies="NR";
if ($md=="0501") $dies="JD";
if ($md=="0705") $dies="CM";
if ($md=="0928") $dies="SV";
$K[$Y.$md]=array(
$Svatky[$md][0]=='S'?'S':$volno,
$Svatky[$md][1],
$Svatky[$md][2],
$Svatky[$md][3],
isset($Svatky[$md][4])?$Svatky[$md][4]:"",
"",$oW,"",$dies);
if ($Svatky[$md][2]=='L') {$K[$Y.$md][5]=$K[$Y.$md][3]; $K[$Y.$md][3]="";} // jmeniny->slavnost
$tm=strtotime("+1 day",$tm);
} // Druhý průchod generuje pohyblivé svátky, lit.barvy, círk.týdny
$tm=mktime(0,0,0,1,1,$Y);
// Svátek Křtu Páně se slaví v první neděli po 6.lednu (7...13.), a je zároveň 1.neděle v mezidobí
$tmKrP=strtotime("next Sunday",mktime(0,0,0,1,6,$Y));
while ($tm<=$tmKrP)
{$Ymd=date("Ymd",$tm);
$K[$Ymd][4]='B';
$K[$Ymd][7]="Doba vánoční";
$tm=strtotime("+1 day",$tm);
} $K[date("Ymd",$tmKrP)][5]="Křest Páně";
$tmVN=easter_date($Y); // Velikonoční neděle
$tmPS=strtotime("-46 days",$tmVN); // Popeleční středa
// zimní mezidobí končí před Popeleční středou
$ct=1; // číslo týdne mezidobí
while ($tm<$tmPS)
{$Ymd=date("Ymd",$tm);
if (!$K[$Ymd][4]) $K[$Ymd][4]='Z';
if (date("w",$tm)==0) ++$ct;
$K[$Ymd][7]="$ct. v mezidobí";
$tm=strtotime("+1 day",$tm);
}
$cMezidobi=$ct; // číslo posledního týdne zimního mezidobí
$K[date("Ymd",$tm)][4]='F';
$K[date("Ymd",$tm)][5]="Popeleční středa";
$K[date("Ymd",$tm)][8]="P3";
// Postní období končí Bilou sobotou
$tmZC=strtotime("-3 days",$tmVN); // Zelený čtvrtek
$ct=0; // číslo postního týdne
while ($tm<$tmZC)
{$Ymd=date("Ymd",$tm);
if (!$K[$Ymd][4]) $K[$Ymd][4]='F';
if (date("w",$tm)==0) {++$ct;
  if ($ct==4) $K[$Ymd][4]='R'; // 4.neděle postní je Růžová
  if ($ct==6) $K[$Ymd][5]="Květná neděle"; // 6.neděle postní je Květná
 }
$K[$Ymd][7]="$ct. postní";
$tm=strtotime("+1 day",$tm);
} // Velikonoční triduum
$Ymd=date("Ymd",$tm);
$K[$Ymd][2]='S';
$K[$Ymd][4]='B';
$K[$Ymd][5]="Zelený čtvrtek";
$K[$Ymd][7]="$ct. postní";
$K[$Ymd][8]="Z4";
$tm=strtotime("+1 day",$tm);
$Ymd=date("Ymd",$tm);
$K[$Ymd][2]='S';
$K[$Ymd][4]='C';
$K[$Ymd][5]="Velký pátek";
$K[$Ymd][7]="$ct. postní";
$K[$Ymd][8]="V5";
$tm=strtotime("+1 day",$tm);
$Ymd=date("Ymd",$tm);
$K[$Ymd][2]='S';
$K[$Ymd][4]='F';
$K[$Ymd][5]="Bílá sobota";
$K[$Ymd][7]="$ct. postní";
$K[$Ymd][8]="B6";
$tm=strtotime("+1 day",$tm);
$Ymd=date("Ymd",$tm);
$K[$Ymd][2]='L';
$K[$Ymd][4]='B';
$K[$Ymd][5]="Zmrtvýchvstání Páně";
$K[$Ymd][7]="1. velikonoční";
$K[$Ymd][8]="V7";
$tm=strtotime("+1 day",$tm); // Velikonoční pondělí
$Ymd=date("Ymd",$tm);
$K[$Ymd][0]='S'; // st.svátek
$K[$Ymd][8]="V1";
if (!$K[$Ymd][4]) $K[$Ymd][4]='B';
$tmNVP=strtotime("+39 days",$tmVN); // Nanebevstoupení Páně
$tmSDS=strtotime("+49 days",$tmVN); // Seslání Ducha svatého
$tmN3=strtotime("+56 days",$tmVN); // Nejsvětější Trojice
$tmTKP=strtotime("+60 days",$tmVN); // Tělo a krev Páně
$ct=1; // číslo velikonočního týdne
while ($tm<=$tmSDS)
{$Ymd=date("Ymd",$tm);
if (!$K[$Ymd][4]) $K[$Ymd][4]='B';
if (date("w",$tm)==0) ++$ct;
$K[$Ymd][7]="$ct. velikonoční";
$tm=strtotime("+1 day",$tm);
} // Letní mezidobí a církevní rok končí sobotou před 1.adventní nedělí
$tmAdv=strtotime("-21 days",strtotime("last Sunday",mktime(0,0,0,12,25,$Y))); // 1.adv.neděle
$tmJKK=strtotime("-7 days",$tmAdv); // Krista Krále
$ct=34-round(($tmJKK-$tm)/(7*24*60*60)); // číslo týdne v letním mezidobí
while ($tm<$tmAdv) // $tm začná pondělkem po SDS
{$Ymd=date("Ymd",$tm);
if (!$K[$Ymd][4]) $K[$Ymd][4]='Z';
if (date("w",$tm)==0) ++$ct;
$K[$Ymd][7]="$ct. v mezidobí";
$tm=strtotime("+1 day",$tm);
}
$Ymd=date("Ymd",$tmNVP);
$K[$Ymd][2]='S';
$K[$Ymd][4]='B';
$K[$Ymd][5]="Nanebevstoupení Páně";
$Ymd=date("Ymd",$tmSDS);
$K[$Ymd][2]='L';
$K[$Ymd][4]='C';
$K[$Ymd][5]="Seslání Ducha svatého";
$Ymd=date("Ymd",$tmN3);
$K[$Ymd][2]='L';
$K[$Ymd][4]='B';
$K[$Ymd][5]="Nejsvětější Trojice";
$Ymd=date("Ymd",$tmTKP);
$K[$Ymd][2]='S';
$K[$Ymd][4]='B';
$K[$Ymd][5]="Tělo a krev Páně";
$Ymd=date("Ymd",$tmJKK);
$K[$Ymd][2]='L';
$K[$Ymd][4]='B';
$K[$Ymd][5]="Ježíš Kristus Král";
$tmSD=mktime(0,0,0,12,24,$Y); // Štědrý den
$ct=0; // číslo adventní neděle
while ($tm<=$tmSD) // $tm začíná 1.adv.nedělí
{$Ymd=date("Ymd",$tm);
if (!$K[$Ymd][4]) $K[$Ymd][4]='F';
if (date("w",$tm)==0) {++$ct; if ($ct==3) $K[$Ymd][4]='R';} // 3.neděle adventní je Růžová
$K[$Ymd][7]="$ct. adventní";
$tm=strtotime("+1 day",$tm);
}
$tmNR=mktime(0,0,0,1,1,$Y+1); // Nový rok
while ($tm<$tmNR)
{$Ymd=date("Ymd",$tm);
$K[$Ymd][7]="Doba vánoční";
$tm=strtotime("+1 day",$tm);
} // Svátek svaté Rodiny v neděli mezi 26.-31.prosincem, jinak 30.prosince
$tmSR=strtotime("next Sunday",mktime(0,0,0,12,25,$Y));
if (date("Y",$tmSR)>$Y) $tmSR=mktime(0,0,0,12,30,$Y);
$Ymd=date("Ymd",$tmSR);
$K[$Ymd][2]='S';
$K[$Ymd][5]="Svatá Rodina";
// Hotovo, pevné i pohyblivé svátky jsou spočteny.
$sql="INSERT cache SET Y=$Y,K='".serialize($K)."'";
mysqli_query($db,$sql); if (ChybaDb($db,$sql)) ZobrazChyby();
return $K;
} // endfunction Kalendar

function Cantus() // Výstupní pole $C je cachováno v databázi,
// obdobně jako pole kalendáře s "magickým" rokem $Y=33
// Tento řádek cache [33] je mazán při každé aktualizaci bohoslužby,
// což funkci Cantus() přinutí k novému přepočítání pole $C a tedy k zohlednění právě aktualizované písně.
{$C=array();
// Vrací pole $C se seznamem kancionálních písní
// Číslo písně [1..999] je klíč, hodnotou je pole těchto položek:
// [0] Titul písně
// [1] Kolikrát byla/bude tato píseň hrána (počet jejích výskytů v missa.carmen)
// [2] nejvyšší datum, kdy byla/bude hrána ve tvaru YYYYMMDD
global $db;
$sql="CREATE TABLE IF NOT EXISTS `cache` (
`Y`   SMALLINT UNSIGNED COMMENT 'kalendářní rok',
`K`   LONGBLOB COMMENT 'pole kalendáře',
PRIMARY KEY (`Y`)
) COMMENT 'Cache kalendářů a písní' , ENGINE = myisam;";
mysqli_query($db,$sql); if (ChybaDb($db,$sql)) ZobrazChyby();
$sql="SELECT `K` FROM cache WHERE Y=33;";
if ($sC=@mysqli_fetch_row(mysqli_query($db,$sql))) return unserialize($sC[0]);
// Výpočet pole $C
// Definiční pole obsahuje mešní písně řazené abecedně.
$C[797]=array("Adoremus in aeternum",0,0);
$C[782]=array("Adoro te devote",0,0);
$C[301]=array("Ach, můj nejsladší Ježíši",0,0);
$C[121]=array("Aj, slyšte znenadání",0,0);
$C[401]=array("Aleluja! Živ buď nad smrtí slavný vítěz",0,0);
$C[410]=array("Aleluja, církev zpívá",0,0);
$C[411]=array("Aleluja. Zazpívej, církvi",0,0);
$C[890]=array("Anděle boží, strážce můj",0,0);
$C[889]=array("Andělé boží, modlitby",0,0);
$C[701]=array("Andělský chlebe",0,0);
$C[702]=array("Ať Srdci Ježíšovu",0,0);
$C[282]=array("Betlémské světlo",0,0);
$C[901]=array("Blíž k tobě, Bože můj",0,0);
$C[918]=array("Bože všemocný a vlídný",0,0);
$C[828]=array("Bože, cos ráčil",0,0);
$C[932]=array("Bože, chválíme tebe",0,0);
$C[982]=array("Bože, chválíme tebe",0,0);
$C[512]=array("Bože, před tvou velebností",0,0);
$C[921]=array("Bože, věrným zemřelým",0,0);
$C[483]=array("Bratři, nad svým vykoupením",0,0);
$C[906]=array("Buď Bohu chvála",0,0);
$C[703]=array("Buď slaven, mocný Králi",0,0);
$C[917]=array("Buď ve svátosti",0,0);
$C[885]=array("Buď zdráva, Panno Maria",0,0);
$C[818]=array("Buď zdráva, panen koruno",0,0);
$C[801]=array("Budiž věčně velebena",0,0);
$C[519]=array("Buďte bdělí",0,0);
$C[844]=array("Bůh je láska",0,0);
$C[914]=array("Bůh ti tento život dal",0,0);
$C[402]=array("Bůh všemohoucí",0,0);
$C[122]=array("Co již dávní proroci",0,0);
$C[227]=array("Co to znamenati má",0,0);
$C[289]=array("Co to znamená",0,0);
$C[208]=array("Čas radosti, veselosti",0,0);
$C[791]=array("Dárce spásy, Chlebe živý",0,0);
$C[927]=array("Dej mi, Pane, bdělé srdce",0,0);
$C[821]=array("Dělníku Boží",0,0);
$C[128]=array("Dej rosu, nebe nad námi",0,0);
$C[302]=array("Dokonáno jest",0,0);
$C[786]=array("Dulcis Jesu memoria",0,0);
$C[303]=array("Duše věrné",0,0);
$C[101]=array("Ejhle, Hospodin přijde",0,0);
$C[288]=array("Ejhle, naše chasa",0,0);
$C[795]=array("Ejhle, oběť přesvatá",0,0);
$C[829]=array("Ejhle, oltář",0,0);
$C[123]=array("Ejhle, přijde Pán",0,0);
$C[182]=array("Hlásej píseň veselá",0,0);
$C[403]=array("Hle, vstal již z mrtvých",0,0);
$C[513]=array("Hleď, mocný Hospodine",0,0);
$C[726]=array("Hledám, kde bydlíš, Pane",0,0);
$C[304]=array("Hořké muky",0,0);
$C[383]=array("Hořké Páně umučení",0,0);
$C[520]=array("Hospodine všemohoucí",0,0);
$C[912]=array("Hospodine, mocný Králi",0,0);
$C[514]=array("Hospodine, všech věcí Pane",0,0);
$C[981]=array("Hospodine, pomiluj nás",0,0);
$C[930]=array("Hospodine, pomiluj ny",0,0);
$C[213]=array("Hvězda svítí nad Betlémem",0,0);
$C[883]=array("Hvězdo jitřní",0,0);
$C[787]=array("Chléb, hle jasných nebešťanů",0,0);
$C[220]=array("Chtíc, aby spal",0,0);
$C[105]=array("Chvalme Boha vesele",0,0);
$C[902]=array("Chvalme Hospodáře všehomíra",0,0);
$C[907]=array("Chvalte Pána, chvalte",0,0);
$C[908]=array("Chvalte Pána, všichni lidé",0,0);
$C[704]=array("Chvalte ústa",0,0);
$C[781]=array("Chvalte, ústa",0,0);
$C[802]=array("Chválu vzdejme, ó křesťané",0,0);
$C[319]=array("Já chtěl bych, Bože můj",0,0);
$C[824]=array("Já jsem si vyvolil",0,0);
$C[825]=array("Jak červánky ohlašují ráno",0,0);
$C[124]=array("Jak růže krásná",0,0);
$C[822]=array("Jak se moudrost Boží",0,0);
$C[515]=array("Jako dítky k Otci svému",0,0);
$C[803]=array("Jako ta růžička krásná",0,0);
$C[481]=array("Jako vítěz",0,0);
$C[819]=array("Jakou to vůní dýchá zem",0,0);
$C[219]=array("Jdou zástupy věrných",0,0);
$C[798]=array("Je to jeden chléb",0,0);
$C[910]=array("Jeden Pán",0,0);
$C[832]=array("Ještě než vzpjal se první chrám",0,0);
$C[706]=array("Jezu Kriste, štědrý kněže",0,0);
$C[116]=array("Jezu, skrytý ve svátosti",0,0);
$C[707]=array("Ježíši, Králi",0,0);
$C[708]=array("Ježíši, tebe hledám",0,0);
$C[291]=array("Ježíška vítat pospěšme",0,0);
$C[305]=array("Již jsem dost pracoval",0,0);
$C[709]=array("K nebesům se orla vzletem",0,0);
$C[804]=array("K nebesům dnes zaleť písni",0,0);
$C[839]=array("K oltáři Páně",0,0);
$C[710]=array("K svátku tajemnému",0,0);
$C[711]=array("Kde jsi, Jezu, spáso má",0,0);
$C[727]=array("Kde jsi, můj Ježíši",0,0);
$C[306]=array("Když na kříži pněl Spasitel",0,0);
$C[712]=array("Klaním se ti vroucně",0,0);
$C[783]=array("Klaním se ti vroucně",0,0);
$C[841]=array("Kolik svatých zdobí nebe",0,0);
$C[318]=array("Kriste Králi, dárce spásy",0,0);
$C[386]=array("Kriste, pro tvé rány",0,0);
$C[217]=array("Kriste, světa Spasiteli",0,0);
$C[421]=array("Kristus seslal Těšitele",0,0);
$C[307]=array("Kristus, příklad pokory",0,0);
$C[308]=array("Křesťanská duše",0,0);
$C[385]=array("Kříži svatý",0,0);
$C[72]=array("Křížová cesta",0,0);
$C[73]=array("Křížová cesta",0,0);
$C[74]=array("Křížová cesta",0,0);
$C[834]=array("Lid český",0,0);
$C[65]=array("Litanie k Nejsv. Srdci Ježíšovu",0,0);
$C[68]=array("Litanie ke všem svatým",0,0);
$C[69]=array("Litanie ke sv. ochráncům vlasti",0,0);
$C[67]=array("Litanie loretánská",0,0);
$C[805]=array("Maria, Maria",0,0);
$C[884]=array("Maria, tvé jméno",0,0);
$C[85]=array("Mariánské nešpory",0,0);
$C[806]=array("Máti Páně přesvatá",0,0);
$C[922]=array("Matičko Kristova",0,0);
$C[311]=array("Matka pláče",0,0);
$C[807]=array("Matko Boží, neslýcháno",0,0);
$C[808]=array("Matko přesvatá",0,0);
$C[221]=array("Místo Betléma",0,0);
$C[983]=array("Mluv, Pane",0,0);
$C[102]=array("Mnozí spravedliví",0,0);
$C[89]=array("Modlitba před spaním",0,0);
$C[589]=array("Na kolena padejme s pokorou",0,0);
$C[713]=array("Na kolena padejme",0,0);
$C[516]=array("Na své tváře padáme",0,0);
$C[201]=array("Narodil se Kristus Pán",0,0);
$C[207]=array("Nastal přeradostný čas",0,0);
$C[218]=array("Náš Spasitel zvěstovaný",0,0);
$C[312]=array("Nedejme se k spánku svésti",0,0);
$C[909]=array("Nejvyšší a mocný",0,0);
$C[222]=array("Nesem vám noviny",0,0);
$C[84]=array("Nešpory",0,0);
$C[789]=array("Ó andělé, k nám dolů spějte",0,0);
$C[923]=array("Ó Bože, k prosbám lidu",0,0);
$C[794]=array("Ó Bože, zde se tobě",0,0);
$C[321]=array("Ó hlavo těla církve",0,0);
$C[916]=array("O hojné požehnání",0,0);
$C[790]=array("Ó Jezu, Hoste nebeský",0,0);
$C[384]=array("Ó Kriste, pohlédni",0,0);
$C[309]=array("Ó Kriste, v tichý postní den",0,0);
$C[809]=array("Ó Maria, Boží máti",0,0);
$C[810]=array("Ó Maria, útočiště naše",0,0);
$C[881]=array("Ó Panno líbezná",0,0);
$C[714]=array("Ó pokrme pocestných",0,0);
$C[320]=array("Ó slyš a shlédni k nám",0,0);
$C[382]=array("Ó srdce kamenné",0,0);
$C[715]=array("Ó Srdce Páně",0,0);
$C[728]=array("Ó Srdce Páně nejsvětější",0,0);
$C[826]=array("Od sítí tvých",0,0);
$C[924]=array("Odpočiňte v pokoji",0,0);
$C[911]=array("Otče náš, milý Pane",0,0);
$C[293]=array("Pán je světlo národů",0,0);
$C[484]=array("Pán Ježíš Kristus",0,0);
$C[843]=array("Pane žní",0,0);
$C[521]=array("Pane, chci být jako ty",0,0);
$C[705]=array("Pange, lingua",0,0);
$C[104]=array("Panno blahoslavená, hle anděl",0,0);
$C[984]=array("Panno blahoslavená, Matko milosti",0,0);
$C[882]=array("Panno blahoslavená, nad anděly",0,0);
$C[891]=array("Pějme píseň o Hedvice",0,0);
$C[522]=array("Plníme, Kriste, tvoje přání",0,0);
$C[886]=array("Pod ochranu tvou",0,0);
$C[310]=array("Poděkujme Kristu Pánu",0,0);
$C[511]=array("Pojď, kajícníku, před oltář",0,0);
$C[716]=array("Pojďte uctít poklonou",0,0);
$C[202]=array("Pojďte všichni k jesličkám",0,0);
$C[586]=array("Pokrop mě yzopem",0,0);
$C[281]=array("Poslechněte, národové",0,0);
$C[223]=array("Poslouchejte, křesťané",0,0);
$C[287]=array("Poslyště, bratři, jen",0,0);
$C[793]=array("Pozdraven buď ve svátosti",0,0);
$C[517]=array("Pozdvihni se, duše z prachu",0,0);
$C[115]=array("Požehnaný, velebný",0,0);
$C[842]=array("Prolití krve",0,0);
$C[110]=array("Prolom, Pane, nebesa",0,0);
$C[113]=array("Před Pána vstupujem",0,0);
$C[591]=array("Před tebou hlavu sklání",0,0);
$C[322]=array("Před tvou tváří",0,0);
$C[925]=array("Při tvé lásce neslýchané",0,0);
$C[422]=array("Přijď, ó Duchu přesvatý",0,0);
$C[215]=array("Přijď, ó milý Spasiteli",0,0);
$C[423]=array("Přijď, Tvůrce Duchu svatý",0,0);
$C[913]=array("Přísný soudce",0,0);
$C[313]=array("Přistup, duše, v zkroušenosti",0,0);
$C[510]=array("Rač yzopem mě pokropit",0,0);
$C[107]=array("Radostné to Děťátko",0,0);
$C[836]=array("Radostnou píseň",0,0);
$C[404]=array("Raduj se a vesel",0,0);
$C[485]=array("Raduj se, Královno nebeská",0,0);
$C[117]=array("Rodičko Boží vznešená",0,0);
$C[181]=array("Rosu dejte, nebesa",0,0);
$C[405]=array("Rozleťte se, zpěvy, vzhůru",0,0);
$C[286]=array("S chudými pastýři",0,0);
$C[903]=array("S námi je Bůh náš",0,0);
$C[204]=array("S pastýři teď o závod",0,0);
$C[283]=array("S pastýři poslouchejte",0,0);
$C[796]=array("S poníženým k zemi čelem",0,0);
$C[285]=array("Sem, pastýři, pospíchejte",0,0);
$C[424]=array("Sestup na nás, Duchu svatý",0,0);
$C[125]=array("Sešli, nebe, Spasitele",0,0);
$C[518]=array("Shlédni, Bože",0,0);
$C[717]=array("Sióne, chval Spasitele",0,0);
$C[292]=array("Sióne, již otvírej",0,0);
$C[718]=array("Skrytý Bože",0,0);
$C[185]=array("Slavná Matko",0,0);
$C[888]=array("Slavná slova",0,0);
$C[186]=array("Slavná Spasitele Matko",0,0);
$C[811]=array("Slyš, jaký to nad řekou",0,0);
$C[284]=array("Slyšte, slyšte, pastuškové",0,0);
$C[209]=array("Splnilo se Písmo svaté",0,0);
$C[788]=array("Srdce Páně, archo spásy",0,0);
$C[314]=array("Stála Matka",0,0);
$C[784]=array("Svatá oběť začíná se",0,0);
$C[792]=array("Svátosti drahá",0,0);
$C[316]=array("Svatý Bože, svatý Silný",0,0);
$C[315]=array("Svatý Bože",0,0);
$C[317]=array("Svatý kříži, tebe ctíme",0,0);
$C[830]=array("Svatý Václave",0,0);
$C[719]=array("Svatý, svatý",0,0);
$C[838]=array("Svatým bratřím chvály znějí",0,0);
$C[931]=array("Tam, kde strmí církve skála",0,0);
$C[224]=array("Tichá noc",0,0);
$C[812]=array("Tisíckráte pozdravujem tebe",0,0);
$C[590]=array("Tobě, Bože na výsosti",0,0);
$C[412]=array("Třetího dne vstal Stvořitel",0,0);
$C[904]=array("Tvůrce mocný",0,0);
$C[108]=array("Ty jsi, Kriste, Boží Syn",0,0);
$C[523]=array("Ty jsi, Pane, v každém chrámě",0,0);
$C[905]=array("Ty mocný, silný, veliký",0,0);
$C[425]=array("Ty, Boží lásko",0,0);
$C[833]=array("Ty, jenž jsi slavná koruna",0,0);
$C[928]=array("Učiň mě, Pane, nástrojem",0,0);
$C[720]=array("Útěcho duše mé",0,0);
$C[524]=array("V posvátné úctě klekáme",0,0);
$C[210]=array("V půlnoční hodinu",0,0);
$C[831]=array("V zemi věrných Čechů",0,0);
$C[588]=array("V zkroušenosti klekáme",0,0);
$C[592]=array("V zkroušenosti srdce",0,0);
$C[228]=array("Vánoční čas nastává",0,0);
$C[813]=array("Velebí má duše",0,0);
$C[406]=array("Velikonoční oběti",0,0);
$C[407]=array("Vesel se, nebes Královno",0,0);
$C[225]=array("Veselé vánoční hody",0,0);
$C[929]=array("Vezmi si, Pane",0,0);
$C[587]=array("Viděl jsem pramen vody",0,0);
$C[226]=array("Vítaný buď, Ježíšku",0,0);
$C[721]=array("Vítej nám, Hoste přemilý",0,0);
$C[205]=array("Vítej nám, Bože vtělený",0,0);
$C[184]=array("Vítej, Hosti nebeský",0,0);
$C[183]=array("Vítej, Jezu Kriste",0,0);
$C[106]=array("Vítej, milý Jezu Kriste",0,0);
$C[206]=array("Vítej, milý Jezu Kriste",0,0);
$C[216]=array("Vítej, vítej, božské Dítě",0,0);
$C[722]=array("Vítej, vítej, tělo přezázračné",0,0);
$C[103]=array("Vládce světa",0,0);
$C[129]=array("Volá hlas",0,0);
$C[835]=array("Vroucně vyzýván",0,0);
$C[408]=array("Vstalť jest této chvíle",0,0);
$C[415]=array("Vstoupil Pán v slávu nebeskou",0,0);
$C[840]=array("Všichni Boží vyvolení",0,0);
$C[525]=array("Všichni jsme děti Boží",0,0);
$C[111]=array("Všichni věrní křesťané",0,0);
$C[212]=array("Všude radost",0,0);
$C[820]=array("Vychvalujme vesele",0,0);
$C[827]=array("Vyvolil si apoštoly",0,0);
$C[290]=array("Vzhůru, bratři milí",0,0);
$C[723]=array("Vzhůru, srdce",0,0);
$C[892]=array("Vzývej, církvi, svého kněze Jana",0,0);
$C[845]=array("Vždy žena budiž chválena",0,0);
$C[112]=array("Z hvězdy vyšlo slunce",0,0);
$C[785]=array("Z lásky raněný Ježíši",0,0);
$C[109]=array("Z milosti tak hojné",0,0);
$C[211]=array("Z nebe jsi přišel",0,0);
$C[130]=array("Z nebe posel vychází",0,0);
$C[214]=array("Z nebeské výsosti",0,0);
$C[381]=array("Zahlaď, Bože, mou nepravost",0,0);
$C[409]=array("Základ církve pevná skála",0,0);
$C[126]=array("Zavítej k nám, Stvořiteli",0,0);
$C[724]=array("Zde nebeská je mana",0,0);
$C[725]=array("Zdráv buď, Chlebe",0,0);
$C[114]=array("Zdráv buď, Pane Jezu Kriste",0,0);
$C[823]=array("Zdráv buď, strážce",0,0);
$C[815]=array("Zdráva buď, Panno Maria",0,0);
$C[814]=array("Zdráva buď, nebes Královno",0,0);
$C[140]=array("Zdráva buď, Panno Maria",0,0);
$C[817]=array("Zdrávas Maria! Anděl Páně z nebe",0,0);
$C[816]=array("Zdrávas, hvězdo spanilá",0,0);
$C[887]=array("Zdrávas, Královno",0,0);
$C[926]=array("Zpívejme píseň naděje",0,0);
$C[203]=array("Zvěstujem vám radost",0,0);
$C[482]=array("Zvítězil Lev",0,0);
$C[413]=array("Žije! Kristus povstal z hrobu",0,0);

$sql="SELECT datum, carmen FROM missa WHERE ritus<>0 AND carmen<>'';";
$result=mysqli_query($db,$sql);
ChybaDb($db,$sql);
while ($missa=@mysqli_fetch_assoc($result))
{$c=$missa['carmen']; $datum=$missa['datum'];
$carr=str_word_count($missa['carmen'],2,"0123456789");
foreach ($carr as $cantus) {$icantus=(integer)$cantus;
if (isset($C[$icantus]))
 {$C[$icantus][1]+=1;  if ($C[$icantus][2]<$datum) $C[$icantus][2]=$datum;}
}} // endforeach endwhile
// Hotovo, přehled písní $C je aktualizován, uloží se do cache:
$sql="INSERT cache SET Y=33,K='".serialize($C)."'";
@mysqli_query($db,$sql); if (ChybaDb($db,$sql)) ZobrazChyby();
return $C;
} // endf Cantus


?>
