<?php
include "data.php";
include "funkce.php";

ZobrazHlavu("Popis aplikace Missae",true,"POPIS");
echo "<h1>O aplikaci Missae <small>verze ".VERZE."</small></h1>
<div class='PEREX'>Stav informací o bohoslužbách na webových stránkách <a href='http://farnost.katolik.cz/'>
většiny farností</a> je neúplný. Nejčastěji zde nalezneme pouze statické údaje
o&nbsp;pravidelných začátcích mší, mnohdy už několik let neaktualizované.
<br/>Vytvořil jsem proto jednoduchou aplikaci pro plánování katolických bohoslužeb
<strong>Missae</strong>, pomocí níž mohou kněží a pověření členové farnosti
podle oprávnění přidělených administrátorem webu aktualizovat přímo ze svého
internetového prohlížeče údaje o mších, zapisovat intence, ohlášky,
plánovat lektorskou službu a hudební doprovod, případně se domlouvat přímo na webu
pomocí vzkazů viditelných přihlášeným účastníkům.<br/>

</div><br clear='all'/>

<h2 id='popis'>Popis pro farníky a anonymní návštěvníky</h2><br/>
<p>Na domácí stránku farnosti se vracíme klepnutím na její logo nahoře.
Na <a href='index.php'>výchozí stránce</a> aplikace Missae se zobrazuje přehled bohoslužeb
aktuálního kalendářního týdne. Na tuto stránku se vracíme tlačítkem
<input type='submit' value='Dnes' title='Přehled týdne'
onclick='window.location.href=\"index.php\";'/></p>

Dnešní den je zvýrazněn <span class='DNES'>červeným orámováním</span>.
Ke každé bohoslužbě se zobrazují následující informace:
<ul><li><b>Datum</b> včetně <span class='OJ'>občanských</span> a <span class='CJ'>církevních</span> svátků</li>
<li><b>Čas</b> začátku</li>
<li><b>Místo</b> konání (s odkazem na statickou stránku s informací o příslušném kostele, mapou,
navigačními souřadnicemi apod.)
Momentálně jsou nastavena tato místa:
<table><tr>";
for ($i=1;$i<count($loci );$i++)
{if ($loci[$i][2])
echo "<td><a href='".$loci[$i][2]."' title='".$loci[$i][1]."'>".$loci[$i][0]."</a></td>";
else echo "<td><span title='".$loci[$i][1]."'>".$loci[$i][0]."</span></td>";
if (!($i%6)) echo "</tr>\r\n<tr>";}
echo "\r\n</tr></table></li>
<li><b>Druh</b> bohoslužby včetně liturgické barvy a odkazu na popis liturgie, volený z těchto možností:
<table><tr>";
for ($i=1;$i<count($ritui);$i++)
{if ($ritui[$i][2])
echo "<td><a href='".$ritui[$i][2]."' title='".$ritui[$i][1]."'>".$ritui[$i][0]."</a><br/>
<img src='ritus$i.gif' alt='".$ritui[$i][0]."'/></td>";
else echo "<td><span title='".$ritui[$i][1]."'>".$ritui[$i][0]."<br/>
<img src='ritus$i.gif' alt='".$ritui[$i][0]."'/></span></td>";
if (!($i%8)) echo "</tr>\r\n<tr>";
} echo "</tr></table>
Podržením kurzoru nad touto ikonou v týdenním přehledu bohoslužeb
budeme moci zjistit, kdo a kdy údaj o jejím konání naposledy aktualizoval.</li>
<li><b>Intence</b>, popis bohoslužby, <span class='HID'>iniciály celebranta</span></li>
<li>Obsah bohoslužby slova, odkaz na příslušné texty pomocí ikonky <img src='lectio.gif'
alt='texty ze serveru Katolik.cz'/>, <span class='HID'>iniciály lektorů</span></li>
<li>Číslo <span class='ORDINARIUM'>ordinaria</span> a písní z <span class='CARMEN'>kancionálu</span>,
<span class='HID'>iniciály varhaníka</span>.</li>
<li>Ohlášky platné pro příslušný týden.</li></ul>
<p>Při zastavení kurzoru myši nad kterýmkoli tlačítkem nebo obrázkem se v informační bublině zobrazí
stručná informace, případně nápověda, co se stane po kliknutí.
Podržením myši nad obrázkem druhu bohoslužby můžeme zjistit,
kdo a kdy naposledy tyto informace aktualizoval.</p>
<p>K prohlížení plánu na další týdny jsou určena tlačítka <input type='submit' value='&lt; &lt'
title='O týden zpět'/>
a <input type='submit' value='&gt; &gt' title='O týden vpřed'/>.
K rychlejšímu přesunu do budoucnosti nebo minulosti
můžeme využít ročního liturgického kalendáře <input type='submit' value='Kalendář'/>,
který je funkční pro léta Páně 1971 až 2037.</p>
<p>Tlačítko <input type='submit' value='Písně' title='Přehled kancionálních písní'/>
zobrazuje seznam písní ze společného zpěvníku českých a moravských diecézí
a u každého titulu počet, kolikrát a kdy naposledy byla píseň uvedena v přehledu bohoslužeb.
Stiskem tlačítek v záhlaví se tabulka seřadí podle zvoleného údaje, opakovaným stiskem
se směr řazení obrací.</p>
<p>Chceme-li týdenní přehled vytisknout, je vhodné využít tlačítko <input type='submit' value='Tisk'/>,
které otevře novou stránku s týmiž informacemi, avšak bez tlačítek a odkazů, které by beztak na papíře nefungovaly.</p>

<h2 id='odkazy'>Odkazy</h2><br/>
<p>Základní internetová adresa (URL) rozpisu bohoslužeb je
<a href='http://$NazevServeru/$Folder/'>http://$NazevServeru/$Folder/</a>. Ta ukazuje vždy na aktuální týden
v okamžiku jejího použití.</p>
<p>Chceme-li odkázat na rozpis konkrétního týdne, stačí za odkaz přidat parametr <code>index.php?t=YYYYTT</code>,
kde YYYY je rok a TT dvojciferné číslo týdne v občanském kalendáři. Například pro devátý týden roku 2013
bude podoba odkazu<br/>
<a href='http://$NazevServeru/$Folder/index.php?t=201309'>http://$NazevServeru/$Folder/index.php?t=201309</a>.
Na tiskovou verzi odkážeme tak, že namísto <code>index</code> použijeme <code>typus</code>,
tedy <br/><a href='http://$NazevServeru/$Folder/typus.php?t=201309'>http://$NazevServeru/$Folder/typus.php?t=201309</a>.
</p>
<p>Přidáním dalšího parametru k URL <code>#dRRRRMMDD</code> docílíme toho, že se prohlížeč vertikálně
nastaví na konkrétní datum DD.MM.RRRR, například pro úterý 5.března 2013 (10. týden) to bude odkaz<br/>
<a href='http://$NazevServeru/$Folder/index.php?t=201310#d20130305'>http://$NazevServeru/$Folder/index.php?t=201310#d20130305</a>.
Pokud takový odkaz pošleme mailem, příjemci se po jediném klepnutí bez dalšího listování
zobrazí požadovaný den a snadno se tak přesvědčí, že byla naplánována požadovaná intence
nebo že má mít v tomto dni třeba lektorskou službu.</p>

<h2 id='editace'>Po přihlášení</h2><br/>
<p>Farníci, kterým byl administrátorem webu farnosti založen účet, nastavena oprávnění
a zadáno počáteční heslo, mohou upravovat údaje na webu,
jakmile se identifikují svými iniciálami a heslem po stisknutí <input type='submit' value='Přihlášení'
onclick='window.location.href=\"login.php\";'/>. Přihlášenému uživateli se zobrazí
další pomocná tlačítka:
<p><input type='submit' value='Účty'/> Správa, tj. zakládání a mazání uživatelů,
možnost nastavení hesla, oprávnění a kontaktních údajů. Zaškrtnutím odpovídajících okének mohou být
uživatelům nastavena oprávnění k úpravám údajů:
<br/><code>Rit</code> - zadávat a rušit bohoslužby, intence, ohlášky, šablonu.
<br/><code>Lec</code> - zadávat obsah čtení, určovat lektory.
<br/><code>Mus</code> - určovat hudební doprovod.
<br/><code>Hom</code> - spravovat ostatní uživatele a jejich oprávnění.</p>
<p><input type='submit' value='Šablona'/> Zadání pravidelně konaných bohoslužeb,
které se budou zobrazovat ve všech týdnech jako výchozí volby, dokud administrátor neupřesní jinak.
Bohoslužby ze šablony se zobrazují v dosud nenaplánovaných týdnech, včetně daleké budoucnosti.
Jakmile byla aspoň jedna bohoslužba některého dne upravena, například doplněním intence
nebo opravou času konání, obsah šablony je automaticky zkopírován do tohoto dne a její později
provedené změny již se v přehledu bohoslužeb nepromítnou.</p>
<p><input type='submit' value='Vzkazy a záznamy'/> Tento deník zaznamenává,
kdy se který uživatel přihlásil a jaké zásahy prováděl. Lze zde také zapisovat vzkazy
pro ostatní uživatele, které jim budou avizovány elektronickou poštou.</p>
<p><input type='submit' value='Přidat'/> Uživatelům s oprávněním <code>Rit</code>
se v levém sloupci každého dne přehledu mší zobrazí možnost přidat novou bohoslužbu v tomto dni.</p>
<p><input type='submit' value='Upravit'/> Toto tlačítko pod ikonou existující bohoslužby
umožňuje upřesnit její údaje, připadně ji celou zrušit.</p>

<h2 id='instalace'>Návod k instalaci</h2><br/>
<p>K využívání aplikace Missa je nutné, aby poskytovatel prostoru pro webové stránky (webhosting)
umožňoval interpretaci skriptů v jazyce PHP a použití databáze MySQL. Administrátor webových
stránek farnosti zpravidla provozuje jejich identickou kopii na svém domácím počítači
a teprve doma vyzkoušené stránky pak kopíruje na oficiální server webhostingu.
K&nbsp;provozování kopie stránek na domácím počítači je nutné mít na něm nainstalován
webový server, např. IIS, PersonalWebService nebo <a href='http://httpd.apache.org/'>Apache</a>,
dále podporu skriptů <a href='http://windows.php.net/download/'>PHP</a> a databázovou
službu <a href='http://dev.mysql.com/tech-resources/articles/mysql-installer-for-windows.html'>MySQL</a>.
Návod pro zprovoznění trojice Apache, PHP, MySQL na domácím počítači je například
<a href='http://myego.cz/item/instalace-apache-mysql-a-php-na-windows'>zde</a>.
K&nbsp;ovládání služby MySQL a počátečnímu založení databáze a jejího uživatele
budete potřebovat vhodný nástroj, jako např. <a href='http://www.phpmyadmin.net'>phpMyAdmin</a>
nebo <a href='http://www.adminer.org'>Adminer</a>.</p>
<p>Čeština je v databázi i ve skriptech Missae kódována v UTF-8, pro úpravu skriptů je tedy nutné mít
plaintextový editor, který s tímto kódováním umí pracovat, například <a href='http://www.pspad.com/'>PSPad</a>
(nelze použít Notepad/Poznámkový blok ani Word).</p>
<!---
<p>Ještě před instalací se můžete seznámit s vlastnostmi aplikace a vyzkoušet libovolné úpravy dat
na její vzorové instalaci pro fiktivní farnost <a href='http://www.vitsoft.info/missae/'>zde</a>.
K přihlášení lze využít účty <b>admin</b>, <b>pater</b>, <b>lektor</b>, <b>kantor</b> nebo <b>ministrant</b>,
heslo je vždy shodné s názvem účtu. Z bezpečnostních důvodů nemají cvičné účty na vzorové instalaci
nastaveno oprávnění <code>Hom</code> a vzkazy se neposílají mailem.</p>
-->

<p>Postup instalace:</p>
<ol><li>Ve výchozím domovském adresáři webu farnosti (webroot) vytvořte podadresář
<b>$Folder</b> a v něm rozbalte poslední verzi aplikace získanou stažením souboru
<a href='https://www.vitsoft.info/missae.zip'>www.vitsoft.info/missae.zip</a>.
<br/>Pokud už jste program používali a chcete pouze provést aktualizaci novější verzí <code>missae.zip</code>,
před jejím rozbalením si zazálohujte soubor <code>data.php</code>.</li>
<li>Soubor <code>missae.zip</code> obsahuje několik obrázků a skriptů v jazyce PHP. Před zprovozněním
aplikace je nezbytné upravit pouze jediný z nich: <code>data.php</code>.
<li>Připojte se ke službě MySQL např. pomocí phpMyAdmin jako uživatel <code>root</code>
a heslem zadaným při instalaci MySQL, případně pomocí údajů, které by měl sdělit webhosting.
Po připojení k MySQL vytvořte novou prázdnou databázi nazvanou např. <code>$Folder</code>
a vytvořte uživatelský účet k této databázi se stejným jménem. Účet musí mít k této databázi oprávnění
CREATE, ALTER, INDEX, DROP.</li>
<li>Otevřte editorem soubor <code>data.php</code> a zadejte přístupové údaje z předchozího kroku
do proměnných <code>\$ServerDb, \$NazevDb, \$KontoDb, \$HesloDb</code>.</li>
<li>Obdobným způsobem zadejte proměnné <code>\$ServerSMTP, \$KontoSMTP, \$HesloSMTP, \$FromSMTP</code>.
Také tyto údaje by měl poskytnout webhosting. Na domácím počítači jsou to stejné údaje,
kterými konfigurujete svého emailového klienta Outlook, Thunderbird apod.
Nebudou-li údaje SMTP správně nastaveny, Missae nebude možné využít k odesílání mailových vzkazů
mezi přihlášenými účastníky, ale jinak by měla fungovat normálně.</li>
<li>V souboru <code>data.php</code> nadefinujte místa konání bohoslužeb ve vaší farnosti
(pole <code>\$loci</code>) a zkontrolujte také ostatní parametry, zejména \$NazevServeru a \$Folder.</li>
<li>Podívejte se internetovým prohlížečem na stránku aplikace Missae, tj. zadejte
adresu <a href='http://$NazevServeru/$Folder/'>http://$NazevServeru/$Folder/</a>
anebo prostě klepněte <a href='index.php'>sem</a>..
Měli byste dostat chybové hlášení, že v databázi nejsou vytvořeny tabulky.</li>
<li>Spusťte instalační skript <a href='http://$NazevServeru/$Folder/instaluj.php'>http://$NazevServeru/$Folder/instaluj.php</a>,
který v databázi naformátuje tabulky <code>missa, imago, log, homo</code> a vytvoří provizorní administátorský účet
s názvem a heslem uvedeným v souboru <code>data.php</code>.</li>
<li>Přejděte v prohlížeči na výchozí stránku aplikace Missae. Měl by být vidět
dosud nevyplněný rozpis dnešního týdne. Přihlaste se jako <b>admin</b> s provizorním heslem,
přejděte na stránku <input type='submit' value='Účty'/>,
zvolte si své nové definitivní heslo a v řádku svého účtu <b>$KontoAdm</b>
je vyplňte do obou polí <b>Heslo</b> a <b>Kopie</b>.
Nezapomeňte pak stisknout <input type='submit' value='Uložit'/>.
</li>
<li>Stále na stránce <a href='edihomo.php'>Účty</a> založte účty pro další osoby,
které budou na úpravách přehledu bohoslužeb spolupracovat nebo které mohou figurovat
v rozpisu jako koncelebranti, cizí zpovědníci, lektoři, zpěváci apod.
Pokud chcete, aby se mohli přihlašovat a provádět úpravy, zadejte jim provizorní heslo,
které jim později sdělíte. V opačném případě ponechte políčka Heslo a Kopie prázdná.</li>
<li>Přejděte na stránku <a href='imago.php'>Šablona</a> a pomocí tlačítka
<input type='submit' value='Přidat'/>nadefinujte pravidelně konané bohoslužby,
nejprve o&nbsp;svátcích, a pak pro běžné dny kalendářního týdne.</li>
<li>Po ověření funkčnosti aplikace asi budete chtít upravit její vzhled, především
obrázek <a href='logo.jpg'>loga farnosti</a>, který se zobrazuje v záhlaví,
a možná také upravit barevné odstíny definované v souboru <code>missae.css</code>
do souladu se zbytkem farního webu.</li>
<li>Pokud jste úspěšně vyzkoušeli aplikaci na domácím počítači, překopírujte ji
na web farnosti a postup zopakujte na tomto provozním serveru.
Po úspěšném vytvoření tabulek v databázi je vhodné kvůli bezpečnosti na provozním webu
smazat skript <code>instaluj.php</code>.</li>
<li>Na výchozí stránku vaší farnosti přidejte odkaz na nový přehled bohoslužeb,
tj. adresu <code>/$Folder/</code> nebo <code>/$Folder/index.php</code>
</li>
</ol>

<h2 id='podpora'>Podpora</h2><br/>
<p>Aktuální verze 20230226 oproti prvotní verzi 20120610 změnila zastaralý driver mysql za mysqli,
takže nyní funguje s PHP5 i s PHP7.</p>
<p>Pro řešení problémů s instalací webového serveru, databáze či skriptovacího jazyka
existují specializovaná diskusní fóra i v češtině. Při potížích s aplikací Missae
zkuste vznést dotaz na některém oborovém fóru, případně požádejte o radu
místního IT odborníka.</p>

<h2 id='licence'>Licence</h2><br/>
<p>Aplikace <b>Missae je freeware</b>, tzn. že může být bezplatně využívána a neomezeně šířena
v&nbsp;původní podobě.</p>
<p>Rovněž všechny pomocné služby potřebné k běhu Missae zmíněné v návodu k instalaci
(Apache, PHP, MySQL, phpMyAdmin, PSPad) jsou zdarma k dispozici na svých webových stránkách a
bývají běžně nainstalovány na většině placených i neplacených webhostingů.</p>
<p>Administrátor může při instalaci upravit seznam míst, kde se bohoslužby konají,
dále modifikovat design aplikace, seznam občanských a církevních svátků,
přeložit aplikaci z&nbsp;češtiny do jiného jazyka, přizpůsobit pro jiné křesťanské denominace,
upravit přihlašovací stránku pro šifrované spojení <code>https</code>
(je-li k dispozici serverový certifikát),
upravit kód pro jinou databázi než MySQL, doplnit zálohování obsahu databáze.</p>
<p align='right'><a href='https://vitsoft.info/about.me'>vit\$oft</a> &nbsp; &nbsp; &nbsp; &nbsp;</p>
";
ZobrazPatu();
?>
